# if4054-final-project

## Deskripsi Aplikasi

Sistem end-to-end yang dirancang untuk memprediksi churn pelanggan. Pipeline ini mencakup tahapan data cleaning, data preprocessing, model training dan evaluasi, serta deployment model. Pipeline ini juga dilengkapi mekanisme deteksi data drift menggunakan Population Stability Index (PSI) yang secara otomatis memonitor perubahan distribusi data dan menentukan kapan model perlu dilatih ulang (retraining).

## Tech Stack

- Apache Spark digunakan untuk memproses data besar (big data processing) dan feature engineering.
- Apache Airflow digunakan untuk mengorkestrasi dan menjadwalkan alur kerja (pipeline workflows).
- MLflow digunakan untuk melacak eksperimen, mengelola model, dan mendukung proses deployment.
- Docker digunakan untuk membuat container aplikasi yang ringan dan portable.
- GitLab digunakan untuk sistem version control dan CI/CD (Continuous Integration and Continuous Deployment).

## Requirement

- Docker

## Cara Menjalankan Pipeline

0. Setup file .env
1. Clone repository `git clone https://gitlab.informatika.org/yansans/if4054-final-project.git`
2. Jalankan command `docker compose up -d`
3. Buka halaman
    - `http://localhost:8080` untuk airflow
    - `http://localhost:8081` untuk spark  
    - `http://localhost:5000` untuk mlflow
    - `http://localhost:9000` untuk minio
4. Lakukan setup connection pada dashboard airflow, yaitu pada laman `http://localhost:8080`  
    - Pada navigation bar, buka Admin > Connection
    - Tekan tombol `+` untuk menambah koneksi
    - Masukkan data berikut
        - connection Id : `spark_default`
        - connection Type : `spark`
        - host : `spark://spark-master`
        - port : `7077`
    - Tekan save

## Troubleshoot

Pastikan End Of Line Sequence pada file script .sh adalah LF

## Link Video Demonstrasi

[Video Demo](https://drive.google.com/file/d/1Xpo1_d6Q9GweOX6aFAwCcSJtMenr7ki9/view?usp=sharing)

## Anggota Kelompok
- Ghazi Akmal Fauzan (13521058)
- Yanuar Sano Nur Rasyid (13521110)
- Ahmad Ghulam Ilham (13521118)
- Muhammad Habibi Husni	(13521169)